<%
'*********************************************************************************
' PayPal Admin Console
' PayPal Pro / PayPal Express Checkout
' Capture / Void / Refund Routines
' 7.02
' 26 July 2012
'*********************************************************************************

sub dopaypalcapture (paymenttype)
   dim transactionid,transactionidpos
   transactionidpos = instr(lcase(oauthorization),"transaction id")
   transactionid = mid(oauthorization,transactionidpos,len(oauthorization)-(transactionidpos-1))
   dim transactionidary(10),transactionidcnt

   dim split_result,j,item,split_param,formname,formvalue
   split_result = split(transactionid,"<br>")
   j=0
   for each item in split_result
      split_param = split(split_result(j),"=")
      formname = split_param(0)
      formvalue = split_param(1)
	  if ucase(formname)  = "TRANSACTION ID" then transactionid = formvalue
      j = j + 1
   next
   DoCaptureXML transactionid,paymenttype
end sub

sub DoCaptureXML (transactionid,paymenttype)
   dim anrequest,Responsedata
   anrequest = ""
   anrequest = anrequest & ""& Server.URLEncode("METHOD") &"=" & Server.URLEncode("DoCapture")
   AuthenticateXML anrequest
   anrequest = anrequest & "&"& Server.URLEncode("AUTHORIZATIONID") &"=" & Server.URLEncode(transactionid)
   anrequest = anrequest & "&"& Server.URLEncode("AMT") &"=" & Server.URLEncode(formatnumber(orderamount,2))
   anrequest = anrequest & "&"& Server.URLEncode("COMPLETETYPE") &"=" & Server.URLEncode("Complete")
   SendtoPayPalGateWay x_GatewayLocation, anrequest, Responsedata

   '702 - 2013.03.25 - Security updates - To remove sensitive details if recording paypal logs
   dim requesttolog
   requesttolog = ""
   requesttolog = requesttolog & ""& Server.URLEncode("METHOD") &"=" & Server.URLEncode("DoCapture")
   requesttolog = requesttolog & "&"& Server.URLEncode("AUTHORIZATIONID") &"=" & Server.URLEncode(transactionid)
   requesttolog = requesttolog & "&"& Server.URLEncode("AMT") &"=" & Server.URLEncode(formatnumber(orderamount,2))
   requesttolog = requesttolog & "&"& Server.URLEncode("COMPLETETYPE") &"=" & Server.URLEncode("Complete")
   createlogs_ecpro_method paymenttype, orderid, requesttolog, Responsedata, "DoCapture"

   AnalyzeResult_DoCapture Responsedata,paymenttype
end sub

Sub AnalyzeResult_DoCapture(result,paymenttype)
   dim split_resultXML,j,item,split_param,formname,formvalue
   dim strACK, strTRANSACTIONID, strpendingreason, strerror, strerrorcode, strPayStatus, strAUTHORIZATIONID
   split_resultXML = split(result,"&")
   j=0
   for each item in split_resultXML
      split_param = split(split_resultXML(j),"=")
      formname = URLDecode(split_param(0))
      formvalue = URLDecode(split_param(1))
      if ucase(formname)  = "ACK" then strACK = formvalue
	  if ucase(formname)  = "TRANSACTIONID" then strTRANSACTIONID = formvalue
	  if ucase(formname)  = "PENDINGREASON" then strpendingreason = formvalue
	  if ucase(formname)  = "L_ERRORCODE0" then strerrorcode = formvalue
	  if ucase(formname)  = "L_LONGMESSAGE0" then strerror = formvalue
	  if ucase(formname)  = "PAYMENTSTATUS" then strPayStatus = formvalue
	  if ucase(formname)  = "AUTHORIZATIONID" then strAUTHORIZATIONID = formvalue
      j = j + 1
   next

   if lcase(strACK) <> "success" and lcase(strACK) <> "successwithwarning" then
      SError = strerror
   else
      UpdateCapture paymenttype,orderid,strPayStatus,strACK,strAUTHORIZATIONID,strTRANSACTIONID,strpendingreason
      ResponseRedirect backurl
   end if
end sub

Sub UpdateCapture (paymenttype,orderid,strPayStatus,strACK,strAUTHORIZATIONID,strTRANSACTIONID,strpendingreason)
   dim sql
   dim PauthCode
   dim strprefix
   assignstrprefix paymenttype,strprefix

   if lcase(strPayStatus) <> "completed" then
      PauthCode = ""& strprefix &"-" & strACK
	  PauthCode = PauthCode & "<br>Transaction ID=" & strAUTHORIZATIONID
	  PauthCode = PauthCode & "<br>Pending Reason=" & strpendingreason
   else
      PauthCode = ""& strprefix &"-" & strACK
      PauthCode = PauthCode & "<br>Transaction ID=" & strAUTHORIZATIONID
	  PauthCode = PauthCode & "<br>Capture Transaction ID=" & strTRANSACTIONID
   end if
   	
   sql = "Update orders set "
   sql = sql & " oauthorization='" & pAuthCode & "'"
   if lcase(strPayStatus) <> "completed" then
      sql = sql & " ,ocardtype='" & ""& strprefix &"-Pending" &"'"
   else
      sql = sql & " ,ocardtype='" & ""& strprefix &"" &"'"
   end if
   sql = sql & " ,paypaltranstype='S'"
   sql = sql & " where orderid=" & orderid
   dbc.execute(sql)
end sub

sub dopaypalrefund (paymenttype)
   dim transactionid,transactionidpos,capturetransactionid
   capturetransactionid = ""
   transactionidpos = instr(lcase(oauthorization),"transaction id")
   transactionid = mid(oauthorization,transactionidpos,len(oauthorization)-(transactionidpos-1))
   dim transactionidary(10),transactionidcnt

   dim split_result,j,item,split_param,formname,formvalue
   split_result = split(transactionid,"<br>")
   j=0
   for each item in split_result
      split_param = split(split_result(j),"=")
      formname = split_param(0)
      formvalue = split_param(1)
	  if ucase(formname)  = "TRANSACTION ID" then transactionid = formvalue
	  if ucase(formname)  = "CAPTURE TRANSACTION ID" then capturetransactionid = formvalue
      j = j + 1
   next
   
   dim passtransactionid
   if trim(capturetransactionid) <> "" then
      passtransactionid = capturetransactionid
   else
      passtransactionid = transactionid
   end if
   DoRefundXML passtransactionid,transactionid,capturetransactionid,paymenttype
end sub

sub DoRefundXML (passtransactionid,transactionid,capturetransactionid,paymenttype)
   dim anrequest,Responsedata
   anrequest = ""
   anrequest = anrequest & ""& Server.URLEncode("METHOD") &"=" & Server.URLEncode("RefundTransaction")
   AuthenticateXML anrequest
   anrequest = anrequest & "&"& Server.URLEncode("TRANSACTIONID") &"=" & Server.URLEncode(passtransactionid)

   dim refundtype,refundamt
   dim orderamt,refundedamt
   refundtype = cleanchars(request("refundtype"))
   refundamt = cleanchars(request("refundamt"))
   if lcase(refundtype) = "partial" then
      if not isnumeric(refundamt) then
	     SError = getlang("langpaypalrefundamtinvalid")
	     exit sub
	  end if
	  getorderspaypaldetails orderid,orderamt,refundedamt
	  if (cdbl(refundamt) + cdbl(refundedamt)) > cdbl(orderamt) then
	     SError = getlang("langpaypalrefundamterrormsg")
		 exit sub
	  end if
	  anrequest = anrequest & "&"& Server.URLEncode("REFUNDTYPE") &"=" & Server.URLEncode("Partial")
	  anrequest = anrequest & "&"& Server.URLEncode("AMT") &"=" & Server.URLEncode(formatnumber(refundamt,2))
   elseif lcase(refundtype) = "full" then
      getorderspaypaldetails orderid,orderamt,refundedamt
	  if cdbl(refundedamt) > 0 then
	     refundamt = cdbl(orderamt) - cdbl(refundedamt)
		 anrequest = anrequest & "&"& Server.URLEncode("REFUNDTYPE") &"=" & Server.URLEncode("Partial")
		 anrequest = anrequest & "&"& Server.URLEncode("AMT") &"=" & Server.URLEncode(formatnumber(refundamt,2))
      else
	     anrequest = anrequest & "&"& Server.URLEncode("REFUNDTYPE") &"=" & Server.URLEncode("FULL")
	     anrequest = anrequest & "&"& Server.URLEncode("AMT") &"=" & Server.URLEncode(formatnumber(orderamount,2))
	  end if
   end if
   SendtoPayPalGateWay x_GatewayLocation, anrequest, Responsedata

   '702 - 2013.03.25 - Security updates - To remove sensitive details if recording paypal logs
   dim requesttolog
   requesttolog = ""
   requesttolog = requesttolog & ""& Server.URLEncode("METHOD") &"=" & Server.URLEncode("RefundTransaction")
   requesttolog = requesttolog & "&"& Server.URLEncode("TRANSACTIONID") &"=" & Server.URLEncode(passtransactionid)
   if lcase(refundtype) = "partial" then
	  requesttolog = requesttolog & "&"& Server.URLEncode("REFUNDTYPE") &"=" & Server.URLEncode("Partial")
	  requesttolog = requesttolog & "&"& Server.URLEncode("AMT") &"=" & Server.URLEncode(formatnumber(refundamt,2))
   elseif lcase(refundtype) = "full" then
	  if cdbl(refundedamt) > 0 then
		 requesttolog = requesttolog & "&"& Server.URLEncode("REFUNDTYPE") &"=" & Server.URLEncode("Partial")
		 requesttolog = requesttolog & "&"& Server.URLEncode("AMT") &"=" & Server.URLEncode(formatnumber(refundamt,2))
      else
	     requesttolog = requesttolog & "&"& Server.URLEncode("REFUNDTYPE") &"=" & Server.URLEncode("FULL")
	     requesttolog = requesttolog & "&"& Server.URLEncode("AMT") &"=" & Server.URLEncode(formatnumber(orderamount,2))
	  end if
   end if
   createlogs_ecpro_method paymenttype, orderid, requesttolog, Responsedata, "RefundTransaction"

   analyzeResult_DoRefund Responsedata,transactionid,capturetransactionid,paymenttype,refundtype,refundamt
end sub

Sub analyzeResult_DoRefund(result,transactionid,capturetransactionid,paymenttype,refundtype,refundamt)
   dim split_resultXML,j,item,split_param,formname,formvalue
   dim strACK, strREFUNDTRANSACTIONID, strGROSSREFUNDAMT, strFEEREFUNDAMT, strNETREFUNDAMT, strPayStatus, strAUTHORIZATIONID, strerrorcode, strerror
   split_resultXML = split(result,"&")
   j=0
   for each item in split_resultXML
      split_param = split(split_resultXML(j),"=")
      formname = URLDecode(split_param(0))
      formvalue = URLDecode(split_param(1))
      if ucase(formname)  = "ACK" then strACK = formvalue
	  if ucase(formname)  = "REFUNDTRANSACTIONID" then strREFUNDTRANSACTIONID = formvalue
	  if ucase(formname)  = "GROSSREFUNDAMT" then strGROSSREFUNDAMT = formvalue
	  if ucase(formname)  = "FEEREFUNDAMT" then strFEEREFUNDAMT = formvalue
	  if ucase(formname)  = "NETREFUNDAMT" then strNETREFUNDAMT = formvalue
	  if ucase(formname)  = "L_ERRORCODE0" then strerrorcode = formvalue
	  if ucase(formname)  = "L_LONGMESSAGE0" then strerror = formvalue
      j = j + 1
   next
   if lcase(strACK) <> "success" and lcase(strACK) <> "successwithwarning" then
      SError = strerror
   else
      UpdateRefund paymenttype,orderid,strACK,strREFUNDTRANSACTIONID,strGROSSREFUNDAMT,strFEEREFUNDAMT,strNETREFUNDAMT,transactionid,capturetransactionid,refundtype,refundamt
      ResponseRedirect backurl
   end if
end sub

Sub UpdateRefund (paymenttype,orderid,strACK,strREFUNDTRANSACTIONID,strGROSSREFUNDAMT,strFEEREFUNDAMT,strNETREFUNDAMT,transactionid,capturetransactionid,refundtype,refundamt)
   dim sql,orders
   dim PauthCode
   dim strprefix
   assignstrprefix paymenttype,strprefix

   sql = "select orderamount,paypalrefundedamt,oauthorization,ocardtype,paypaltranstype from orders where orderid = "& orderid &""
   Set Orders = Server.CreateObject("ADODB.Recordset")
   Orders.open sql, dbc, adOpenDynamic, adLockOptimistic
   PauthCode = Orders("oauthorization")
   PauthCode = PauthCode & "<br>Refund Transaction ID=" & strREFUNDTRANSACTIONID & " : "& strGROSSREFUNDAMT &""
   Orders("oauthorization") = PauthCode
   dim paypalrefundedamt,orderamount
   orderamount = Orders("orderamount")
   paypalrefundedamt = Orders("paypalrefundedamt")
   if isnull(paypalrefundedamt) then paypalrefundedamt = 0
   if trim(paypalrefundedamt) = "" then paypalrefundedamt = 0
   paypalrefundedamt = cdbl(paypalrefundedamt) + cdbl(refundamt)
   Orders("paypalrefundedamt") = paypalrefundedamt
   if lcase(refundtype) = "partial" then
      if cdbl(orderamount) = cdbl(paypalrefundedamt) then
         Orders("ocardtype") = strprefix &"-Refund" &""
         Orders("paypaltranstype") = "R"
	  else
         Orders("ocardtype") = strprefix &"-Partial Refund" &""
         Orders("paypaltranstype") = "S"
	  end if
   else
      Orders("ocardtype") = strprefix &"-Refund" &""
      Orders("paypaltranstype") = "R"
   end if
   orders.update
   closerecordset orders
end sub

sub dopaypalvoid (paymenttype)
   dim transactionid,transactionidpos
   transactionidpos = instr(lcase(oauthorization),"transaction id")
   transactionid = mid(oauthorization,transactionidpos,len(oauthorization)-(transactionidpos-1))
   dim transactionidary(10),transactionidcnt

   dim split_result,j,item,split_param,formname,formvalue
   split_result = split(transactionid,"<br>")
   j=0
   for each item in split_result
      split_param = split(split_result(j),"=")
      formname = split_param(0)
      formvalue = split_param(1)
	  if ucase(formname)  = "TRANSACTION ID" then transactionid = formvalue
      j = j + 1
   next
   DoVoidXML transactionid,paymenttype
end sub

sub DoVoidXML (transactionid,paymenttype)
   dim anrequest,Responsedata
   anrequest = ""
   anrequest = anrequest & ""& Server.URLEncode("METHOD") &"=" & Server.URLEncode("DoVoid")
   AuthenticateXML anrequest
   anrequest = anrequest & "&"& Server.URLEncode("AUTHORIZATIONID") &"=" & Server.URLEncode(transactionid)
   SendtoPayPalGateWay x_GatewayLocation, anrequest, Responsedata

   '702 - 2013.03.25 - Security updates - To remove sensitive details if recording paypal logs
   dim requesttolog
   requesttolog = ""
   requesttolog = requesttolog & ""& Server.URLEncode("METHOD") &"=" & Server.URLEncode("DoVoid")
   requesttolog = requesttolog & "&"& Server.URLEncode("AUTHORIZATIONID") &"=" & Server.URLEncode(transactionid)
   createlogs_ecpro_method paymenttype, orderid, requesttolog, Responsedata, "DoVoid"

   analyzeResult_DoVoid Responsedata,transactionid,paymenttype
end sub

Sub analyzeResult_DoVoid(result,transactionid,paymenttype)
   dim split_resultXML,j,item,split_param,formname,formvalue
   dim strACK, strVoidid,strerrorcode,strerror
   split_resultXML = split(result,"&")
   j=0
   for each item in split_resultXML
      split_param = split(split_resultXML(j),"=")
      formname = URLDecode(split_param(0))
      formvalue = URLDecode(split_param(1))
      if ucase(formname)  = "ACK" then strACK = formvalue
	  if ucase(formname)  = "AUTHORIZATIONID" then strVoidid = formvalue
	  if ucase(formname)  = "L_ERRORCODE0" then strerrorcode = formvalue
	  if ucase(formname)  = "L_LONGMESSAGE0" then strerror = formvalue
      j = j + 1
   next
   if lcase(strACK) <> "success" and lcase(strACK) <> "successwithwarning" then
      SError = strerror
   else
      UpdateVoid paymenttype,orderid,strACK,strVoidid,transactionid
      ResponseRedirect backurl
   end if
end sub

Sub UpdateVoid (paymenttype,orderid,strACK,strVoidid,transactionid)
   dim sql
   dim PauthCode
   dim strprefix
   assignstrprefix paymenttype,strprefix

   PauthCode = ""& strprefix &"-"& strACK &""
   PauthCode = PauthCode & "<br>Transaction ID=" & transactionid
   PauthCode = PauthCode & "<br>Void Transaction ID=" & strVoidid
   	
   sql = "Update orders set "
   sql = sql & " oauthorization='" & pAuthCode & "'"
   sql=sql & " ,ocardtype='" & ""& strprefix &"-Void" &"'"
   sql = sql & " ,paypaltranstype='V'"
   sql = sql & " where orderid=" & orderid
   dbc.execute(sql)
end sub

Sub SendtoPayPalGateWay (gatewaylocation, anrequest, result)
   on error resume next
   dim resultXML,xmlerror

   '800 - 2016.02.03 - XML: To support TLS1.2
   dim rheadercnt, rheadertypeary(10), rheadervalueary(10)
   rheadercnt = 0
   Shopxmlhttp_v8 "auto", gatewaylocation, anrequest, resultXML, "POST", xmlerror, rheadercnt, rheadertypeary, rheadervalueary, "", ""

   result = resultXML
   on error goto 0

   if trim(xmlerror) <> "" then
	  pError="Err. Description: "& xmlerror &""
	  setsess "PaymentError", pError
	  ResponseRedirect backurl
   end if

   If Err.Number <> 0 Then
	  pError="Err. Number: "& Err.Number &"<br>Err. Description: "& Err.Description &""
	  setsess "PaymentError", pError
	  ResponseRedirect backurl
   End If
end sub

Function URLDecode(byVal encodedstring)
   Dim strIn, strOut, intPos, strLeft
   Dim strRight, intLoop
   strIn  = encodedstring : strOut = "" : intPos = Instr(strIn, "+")
   Do While intPos
      strLeft = "" : strRight = ""
      If intPos > 1 then strLeft = Left(strIn, intPos - 1)
	  If intPos < len(strIn) then strRight = Mid(strIn, intPos + 1)
	  strIn = strLeft & " " & strRight
	  intPos = InStr(strIn, "+")
	  intLoop = intLoop + 1
   Loop
   intPos = InStr(strIn, "%")
   Do while intPos
	  If intPos > 1 then strOut = strOut & Left(strIn, intPos - 1)
	  strOut = strOut & Chr(CInt("&H" & mid(strIn, intPos + 1, 2)))
	  If intPos > (len(strIn) - 3) then
		 strIn = ""
	  Else
		 strIn = Mid(strIn, intPos + 3)
	  End If
	  intPos = InStr(strIn, "%")
   Loop
   URLDecode = strOut & strIn
End Function

sub FormatRow (fieldname, fieldvalue, caption,passhelpstring)
   if caption = "" then
      caption = fieldname
   end if
   HtmlWrite tablerow & tableColumn & trim(caption) & tablecolumnend
   HtmlWrite "<td><input class=""txtfield"" size=""20"" name=" & fieldname & " value=" & chr(34) & fieldvalue & chr(34) & ">"
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td></tr>"
end sub

sub FormatRowRadioJS (fieldname, fieldvalue, fieldvaluecaption, fieldvaluejs, caption, wrappername, passhelpstring)
   if caption = "" then
      caption = fieldname
   end if
   dim fieldvaluecaptionary(10),fieldvaluecaptionarycnt,fieldvaluejsary(10),fieldvaluejsarycnt
   ParseRecord fieldvaluecaption,fieldvaluecaptionary,fieldvaluecaptionarycnt,","
   ParseRecord fieldvaluejs,fieldvaluejsary,fieldvaluejsarycnt,";"
   dim icnt,selectedstring,jsstring
   HtmlWrite tablerow & tableColumn & trim(caption) & tablecolumnend
   HtmlWrite "<td>"
   for icnt = 0 to (fieldvaluecaptionarycnt - 1)
      selectedstring = ""
	  if lcase(fieldvaluecaptionary(icnt)) = lcase(fieldvalue) then selectedstring = "checked"
	  jsstring = ""
	  if trim(fieldvaluejsary(icnt)) <> "" then jsstring = fieldvaluejsary(icnt)
      HtmlWrite "<input name="""& fieldname &""" type=""radio"" value="""& fieldvaluecaptionary(icnt) &""" "& selectedstring &" "& jsstring &" /> "& fieldvaluecaptionary (icnt) &""
   next
   htmlwrite "<span id="""& wrappername &"""></span>"
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td></tr>"
end sub

sub createlogs_ecpro_method (paymenttype, oid, xmlsent, xmlreceive, methodtype)
   dim foldername,filename,nowdate
   nowdate = replace(date(),"/","_")
   nowdate = replace(nowdate,"\","_")
   select case lcase(paymenttype)
      case "paypalec"
         foldername = "express"
         filename = "express_"& nowdate &"_"& oid &".txt"
	  case "paypalpro"
         foldername = "paypalpro"
         filename = "paypalpro_"& nowdate &"_"& oid &".txt"
   end select

   WriteLogPayPal foldername, filename, "Start ("& methodtype &"): =================================================="
   WriteLogPayPal foldername, filename, "For Order ID: "& oid &""
   WriteLogPayPal foldername, filename, "XML Sent: "& xmlsent &""
   WriteLogPayPal foldername, filename, "XML Received: "& xmlreceive &""
   WriteLogPayPal foldername, filename, "End ("& methodtype &"): =================================================="
end sub

sub AuthenticateXML (anrequest)
   anrequest = anrequest & "&"& Server.URLEncode("VERSION") &"=" & Server.URLEncode(x_VERSION)
   anrequest = anrequest & "&"& Server.URLEncode("USER") &"=" & Server.URLEncode(x_USERNAME)
   anrequest = anrequest & "&"& Server.URLEncode("PWD") &"=" & Server.URLEncode(X_PASSWORD)
   anrequest = anrequest & "&"& Server.URLEncode("SIGNATURE") &"=" & Server.URLEncode(x_SIGNATURE)
end sub

sub assignstrprefix (paymenttype,prefix)
   select case lcase(paymenttype)
      case "paypalec"
         prefix = "PayPal Express Checkout"
	  case "paypalpro"
         prefix = "PayPalPro-DP"
   end select
end sub
%>