<%
'*********************************************************************************
' PayPal Admin Console
' PayPay Payments Advanced / PayFlow Pro / PayFlow Link
' Capture / Void / Refund Routines
' 7.02
' 26 July 2012
'*********************************************************************************

sub dopaypalcapture (paymenttype)
   dim transactionid,transactionidpos,pprefno
   transactionidpos = instr(lcase(oauthorization),"ppref. no")
   transactionid = mid(oauthorization,transactionidpos,len(oauthorization)-(transactionidpos-1))
   dim transactionidary(10),transactionidcnt

   dim split_result,j,item,split_param,formname,formvalue
   split_result = split(transactionid,"<br>")
   j=0
   for each item in split_result
      split_param = split(split_result(j),":")
      formname = trim(split_param(0))
      formvalue = trim(split_param(1))
	  if ucase(formname) = "PPREF. NO" then pprefno = formvalue
	  if ucase(formname) = "PNREF. NO" then transactionid = formvalue
      j = j + 1
   next
   DoCaptureXML transactionid,paymenttype
end sub

sub DoCaptureXML (transactionid,paymenttype)
   dim anrequest,Responsedata,gatewaystring
   AuthenticateXML paymenttype,anrequest,"Yes",gatewaystring
   payflowvcr_dostring anrequest,"TRXTYPE","D"
   payflowvcr_dostring anrequest,"ORIGID",transactionid
   'payflowvcr_dostring anrequest,"CAPTURECOMPLETE","Y"
   SendtoPayPalGateWay gatewaystring, anrequest, Responsedata

   '702 - 2013.03.25 - Security updates - To remove sensitive details if recording paypal logs
   dim requesttolog
   requesttolog = ""
   payflowvcr_dostring requesttolog,"TRXTYPE","D"
   payflowvcr_dostring requesttolog,"ORIGID",transactionid
   createlogs_payflow_method paymenttype, orderid, requesttolog, Responsedata, "DoCapture"

   AnalyzeResult_DoCapture Responsedata,paymenttype
end sub

Sub AnalyzeResult_DoCapture(result,paymenttype)
   dim split_resultXML,j,item,split_param,formname,formvalue
   dim strRESULT, strPNREF, strRESPMSG
   split_resultXML = split(result,"&")
   j=0
   for each item in split_resultXML
      split_param = split(split_resultXML(j),"=")
      formname = URLDecode(split_param(0))
      formvalue = URLDecode(split_param(1))
      if ucase(formname)  = "RESULT" then strRESULT = formvalue
	  if ucase(formname)  = "PNREF" then strPNREF = formvalue
	  if ucase(formname)  = "RESPMSG" then strRESPMSG = formvalue
      j = j + 1
   next

   if lcase(strRESULT) <> "0"  then
      SError = strRESPMSG
   else
      UpdateCapture paymenttype,orderid,strPNREF
      ResponseRedirect backurl
   end if
end sub

Sub UpdateCapture (paymenttype,orderid,strPNREF)
   dim sql,orders
   dim PauthCode
   dim strprefix
   assignstrprefix paymenttype,strprefix

   sql = "select oauthorization,ocardtype,paypaltranstype from orders where orderid = "& orderid &""
   Set Orders = Server.CreateObject("ADODB.Recordset")
   Orders.open sql, dbc, adOpenDynamic, adLockOptimistic
   PauthCode = Orders("oauthorization")
   PauthCode = PauthCode & "<br>Capture PNRef. No: "& strPNREF &""
   Orders("oauthorization") = PauthCode
   Orders("ocardtype") = strprefix
   Orders("paypaltranstype") = "S"
   orders.update
   closerecordset orders
end sub

sub dopaypalrefund (paymenttype)
   dim transactionid,transactionidpos,capturetransactionid,pprefno
   capturetransactionid = ""
   transactionidpos = instr(lcase(oauthorization),"ppref. no")
   transactionid = mid(oauthorization,transactionidpos,len(oauthorization)-(transactionidpos-1))
   dim transactionidary(10),transactionidcnt

   dim split_result,j,item,split_param,formname,formvalue
   split_result = split(transactionid,"<br>")
   j=0
   for each item in split_result
      split_param = split(split_result(j),":")
      formname = trim(split_param(0))
      formvalue = trim(split_param(1))
	  if ucase(formname) = "PPREF. NO" then pprefno = formvalue
	  if ucase(formname)  = "PNREF. NO" then transactionid = formvalue
	  if ucase(formname)  = "CAPTURE PNREF. NO" then capturetransactionid = formvalue
      j = j + 1
   next
   
   dim passtransactionid
   if trim(capturetransactionid) <> "" then
      passtransactionid = capturetransactionid
   else
      passtransactionid = transactionid
   end if
   DoRefundXML passtransactionid,paymenttype
end sub

sub DoRefundXML (passtransactionid,paymenttype)
   dim anrequest,Responsedata,gatewaystring
   AuthenticateXML paymenttype,anrequest,"",gatewaystring
   payflowvcr_dostring anrequest,"TRXTYPE","C"
   payflowvcr_dostring anrequest,"ORIGID",passtransactionid

   dim refundtype,refundamt
   dim orderamt,refundedamt
   refundtype = cleanchars(request("refundtype"))
   refundamt = cleanchars(request("refundamt"))
   if lcase(refundtype) = "partial" then
      if not isnumeric(refundamt) then
	     SError = getlang("langpaypalrefundamtinvalid")
	     exit sub
	  end if
	  getorderspaypaldetails orderid,orderamt,refundedamt
	  if (cdbl(refundamt) + cdbl(refundedamt)) > cdbl(orderamt) then
	     SError = getlang("langpaypalrefundamterrormsg")
		 exit sub
	  end if
	  payflowvcr_dostring anrequest,"AMT",formatnumber(refundamt,2)
   elseif lcase(refundtype) = "full" then
      getorderspaypaldetails orderid,orderamt,refundedamt
	  if cdbl(refundedamt) > 0 then
	     refundamt = cdbl(orderamt) - cdbl(refundedamt)
		 payflowvcr_dostring anrequest,"AMT",formatnumber(refundamt,2)
	  end if
   end if
   SendtoPayPalGateWay gatewaystring, anrequest, Responsedata

   '702 - 2013.03.25 - Security updates - To remove sensitive details if recording paypal logs
   dim requesttolog
   requesttolog = ""
   payflowvcr_dostring requesttolog,"TRXTYPE","C"
   payflowvcr_dostring requesttolog,"ORIGID",passtransactionid
   payflowvcr_dostring requesttolog,"AMT",formatnumber(refundamt,2)
   createlogs_payflow_method paymenttype, orderid, requesttolog, Responsedata, "RefundTransaction"

   analyzeResult_DoRefund Responsedata,paymenttype,refundtype,refundamt
end sub

Sub analyzeResult_DoRefund(result,paymenttype,refundtype,refundamt)
   dim split_resultXML,j,item,split_param,formname,formvalue
   dim strRESULT, strPNREF, strRESPMSG
   split_resultXML = split(result,"&")
   j=0
   for each item in split_resultXML
      split_param = split(split_resultXML(j),"=")
      formname = URLDecode(split_param(0))
      formvalue = URLDecode(split_param(1))
      if ucase(formname)  = "RESULT" then strRESULT = formvalue
	  if ucase(formname)  = "PNREF" then strPNREF = formvalue
	  if ucase(formname)  = "RESPMSG" then strRESPMSG = formvalue
      j = j + 1
   next

   if lcase(strRESULT) <> "0"  then
      SError = strRESPMSG
   else
      UpdateRefund paymenttype,orderid,strPNREF,refundtype,refundamt
      ResponseRedirect backurl
   end if
end sub

Sub UpdateRefund (paymenttype,orderid,strPNREF,refundtype,refundamt)
   dim sql,orders
   dim PauthCode
   dim strprefix
   assignstrprefix paymenttype,strprefix

   sql = "select orderamount,paypalrefundedamt,oauthorization,ocardtype,paypaltranstype from orders where orderid = "& orderid &""
   Set Orders = Server.CreateObject("ADODB.Recordset")
   Orders.open sql, dbc, adOpenDynamic, adLockOptimistic
   PauthCode = Orders("oauthorization")
   if lcase(refundtype) = "partial" then
      PauthCode = PauthCode & "<br>Refund PNRef. No: "& strPNREF &" : "& refundamt &""
   else
      if trim(refundamt) <> "" then
	     PauthCode = PauthCode & "<br>Refund PNRef. No: "& strPNREF &" : "& refundamt &""
	  else
         PauthCode = PauthCode & "<br>Refund PNRef. No: "& strPNREF &" : Full"
	  end if
   end if
   Orders("oauthorization") = PauthCode
   dim paypalrefundedamt,orderamount
   orderamount = Orders("orderamount")
   paypalrefundedamt = Orders("paypalrefundedamt")
   if isnull(paypalrefundedamt) then paypalrefundedamt = 0
   if trim(paypalrefundedamt) = "" then paypalrefundedamt = 0
   paypalrefundedamt = cdbl(paypalrefundedamt) + cdbl(refundamt)
   Orders("paypalrefundedamt") = paypalrefundedamt
   if lcase(refundtype) = "partial" then
      if cdbl(orderamount) = cdbl(paypalrefundedamt) then
         Orders("ocardtype") = strprefix &"-Refund" &""
         Orders("paypaltranstype") = "R"
	  else
         Orders("ocardtype") = strprefix &"-Partial Refund" &""
         Orders("paypaltranstype") = "S"
	  end if
   else
      Orders("ocardtype") = strprefix &"-Refund" &""
      Orders("paypaltranstype") = "R"
   end if
   orders.update
   closerecordset orders
end sub

sub dopaypalvoid (paymenttype)
   dim transactionid,transactionidpos,pprefno
   transactionidpos = instr(lcase(oauthorization),"ppref. no")
   transactionid = mid(oauthorization,transactionidpos,len(oauthorization)-(transactionidpos-1))
   dim transactionidary(10),transactionidcnt

   dim split_result,j,item,split_param,formname,formvalue
   split_result = split(transactionid,"<br>")
   j=0
   for each item in split_result
      split_param = split(split_result(j),":")
      formname = trim(split_param(0))
      formvalue = trim(split_param(1))
	  if ucase(formname) = "PPREF. NO" then pprefno = formvalue
	  if ucase(formname) = "PNREF. NO" then transactionid = formvalue
      j = j + 1
   next
   DoVoidXML transactionid,paymenttype
end sub

sub DoVoidXML (transactionid,paymenttype)
   dim anrequest,Responsedata,gatewaystring
   AuthenticateXML paymenttype,anrequest,"",gatewaystring
   payflowvcr_dostring anrequest,"TRXTYPE","V"
   payflowvcr_dostring anrequest,"ORIGID",transactionid
   SendtoPayPalGateWay gatewaystring, anrequest, Responsedata

   '702 - 2013.03.25 - Security updates - To remove sensitive details if recording paypal logs
   dim requesttolog
   requesttolog = ""
   payflowvcr_dostring requesttolog,"TRXTYPE","V"
   payflowvcr_dostring requesttolog,"ORIGID",transactionid
   createlogs_payflow_method paymenttype, orderid, requesttolog, Responsedata, "DoVoid"

   analyzeResult_DoVoid Responsedata,paymenttype
end sub

Sub analyzeResult_DoVoid(result,paymenttype)
   dim split_resultXML,j,item,split_param,formname,formvalue
   dim strRESULT, strPNREF, strRESPMSG
   split_resultXML = split(result,"&")
   j=0
   for each item in split_resultXML
      split_param = split(split_resultXML(j),"=")
      formname = URLDecode(split_param(0))
      formvalue = URLDecode(split_param(1))
      if ucase(formname)  = "RESULT" then strRESULT = formvalue
	  if ucase(formname)  = "PNREF" then strPNREF = formvalue
	  if ucase(formname)  = "RESPMSG" then strRESPMSG = formvalue
      j = j + 1
   next

   if lcase(strRESULT) <> "0"  then
      SError = strRESPMSG
   else
      UpdateVoid paymenttype,orderid,strPNREF
      ResponseRedirect backurl
   end if
end sub

Sub UpdateVoid (paymenttype,orderid,strPNREF)
   dim sql,orders
   dim PauthCode
   dim strprefix
   assignstrprefix paymenttype,strprefix

   sql = "select oauthorization,ocardtype,paypaltranstype from orders where orderid = "& orderid &""
   Set Orders = Server.CreateObject("ADODB.Recordset")
   Orders.open sql, dbc, adOpenDynamic, adLockOptimistic
   PauthCode = Orders("oauthorization")
   PauthCode = PauthCode & "<br>Void PNRef. No: "& strPNREF &""
   Orders("oauthorization") = PauthCode
   Orders("ocardtype") = strprefix &"-Void" &""
   Orders("paypaltranstype") = "V"
   orders.update
   closerecordset orders
end sub

Sub SendtoPayPalGateWay (gatewaylocation, anrequest, result)
   on error resume next
   dim resultXML,xmlerror

   '800 - 2016.02.03 - XML: To support TLS1.2
   dim rheadercnt, rheadertypeary(10), rheadervalueary(10)
   rheadercnt = 0
   Shopxmlhttp_v8 "auto", gatewaylocation, anrequest, resultXML, "POST", xmlerror, rheadercnt, rheadertypeary, rheadervalueary, "", ""

   result = resultXML
   on error goto 0

   if trim(xmlerror) <> "" then
	  pError="Err. Description: "& xmlerror &""
	  setsess "PaymentError", pError
	  ResponseRedirect backurl
   end if

   If Err.Number <> 0 Then
	  pError="Err. Number: "& Err.Number &"<br>Err. Description: "& Err.Description &""
	  setsess "PaymentError", pError
	  ResponseRedirect backurl
   End If
end sub

Function URLDecode(byVal encodedstring)
   Dim strIn, strOut, intPos, strLeft
   Dim strRight, intLoop
   strIn  = encodedstring : strOut = "" : intPos = Instr(strIn, "+")
   Do While intPos
      strLeft = "" : strRight = ""
      If intPos > 1 then strLeft = Left(strIn, intPos - 1)
	  If intPos < len(strIn) then strRight = Mid(strIn, intPos + 1)
	  strIn = strLeft & " " & strRight
	  intPos = InStr(strIn, "+")
	  intLoop = intLoop + 1
   Loop
   intPos = InStr(strIn, "%")
   Do while intPos
	  If intPos > 1 then strOut = strOut & Left(strIn, intPos - 1)
	  strOut = strOut & Chr(CInt("&H" & mid(strIn, intPos + 1, 2)))
	  If intPos > (len(strIn) - 3) then
		 strIn = ""
	  Else
		 strIn = Mid(strIn, intPos + 3)
	  End If
	  intPos = InStr(strIn, "%")
   Loop
   URLDecode = strOut & strIn
End Function

sub FormatRow (fieldname, fieldvalue, caption,passhelpstring)
   if caption = "" then
      caption = fieldname
   end if
   HtmlWrite tablerow & tableColumn & trim(caption) & tablecolumnend
   HtmlWrite "<td><input class=""txtfield"" size=""20"" name=" & fieldname & " value=" & chr(34) & fieldvalue & chr(34) & ">"
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td></tr>"
end sub

sub FormatRowRadioJS (fieldname, fieldvalue, fieldvaluecaption, fieldvaluejs, caption, wrappername, passhelpstring)
   if caption = "" then
      caption = fieldname
   end if
   dim fieldvaluecaptionary(10),fieldvaluecaptionarycnt,fieldvaluejsary(10),fieldvaluejsarycnt
   ParseRecord fieldvaluecaption,fieldvaluecaptionary,fieldvaluecaptionarycnt,","
   ParseRecord fieldvaluejs,fieldvaluejsary,fieldvaluejsarycnt,";"
   dim icnt,selectedstring,jsstring
   HtmlWrite tablerow & tableColumn & trim(caption) & tablecolumnend
   HtmlWrite "<td>"
   for icnt = 0 to (fieldvaluecaptionarycnt - 1)
      selectedstring = ""
	  if lcase(fieldvaluecaptionary(icnt)) = lcase(fieldvalue) then selectedstring = "checked"
	  jsstring = ""
	  if trim(fieldvaluejsary(icnt)) <> "" then jsstring = fieldvaluejsary(icnt)
      HtmlWrite "<input name="""& fieldname &""" type=""radio"" value="""& fieldvaluecaptionary(icnt) &""" "& selectedstring &" "& jsstring &" /> "& fieldvaluecaptionary (icnt) &""
   next
   htmlwrite "<span id="""& wrappername &"""></span>"
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td></tr>"
end sub

sub createlogs_payflow_method (paymenttype, oid, xmlsent, xmlreceive, methodtype)
   dim foldername,filename,nowdate
   nowdate = replace(date(),"/","_")
   nowdate = replace(nowdate,"\","_")
   select case lcase(paymenttype)
      case "paypaladvanced"
         foldername = "paymentadvanced"
         filename = "paymentadvanced_"& nowdate &"_"& oid &".txt"
      case "payflowlink"
         foldername = "payflowlink"
         filename = "payflowlink_"& nowdate &"_"& oid &".txt"
      case "payflowpro"
         foldername = "payflowpro"
         filename = "payflowpro_"& nowdate &"_"& oid &".txt"
   end select

   WriteLogPayPal foldername, filename, "Start ("& methodtype &"): =================================================="
   WriteLogPayPal foldername, filename, "For Order ID: "& oid &""
   WriteLogPayPal foldername, filename, "XML Sent: "& xmlsent &""
   WriteLogPayPal foldername, filename, "XML Received: "& xmlreceive &""
   WriteLogPayPal foldername, filename, "End ("& methodtype &"): =================================================="
end sub

sub payflowvcr_dostring(pass_paramlist,fname,fvalue)
   if trim(pass_paramlist) = "" then
      pass_paramlist = fname &"="& fvalue
   else
      pass_paramlist = pass_paramlist & "&"&fname &"="& fvalue
   end if
end sub

function checkxml_payflow
   if testobject_payflow ("Msxml2.ServerXMLHTTP") then
      checkxml_payflow = "XML2"
   elseif testobject_payflow ("Microsoft.XMLHTTP") then
      checkxml_payflow = "XML3"
   elseif testobject_payflow ("MSXML2.ServerXMLHTTP.4.0") then
      checkxml_payflow = "XML4"
   else
      checkxml_payflow = "XML2"
   end if
end function

Function testobject_payflow(comIdentity )
   dim xTestObj
   On Error Resume Next
   testobject_payflow = False
   Err.Clear
   Set xTestObj = Server.CreateObject( comIdentity )
   If Err = 0 Then testobject_payflow = True
   Set xTestObj = Nothing
   Err.clear
   on error goto 0
End Function

sub AuthenticateXML (paymenttype,anrequest,tenderflag,gatewaystring)
   dim passuser,passmerchant,passpartner,passpwd,tenderstring
   select case lcase(paymenttype)
      case "paypaladvanced"
         passuser = xpppymt_USER
		 passmerchant = xpppymt_MERCHANT
		 passpartner = xpppymt_PARTNER
		 passpwd = xpppymt_PWD
		 tenderstring = "P"
		 gatewaystring = SEcureTokenGatewayPayPalAdvancedURL
      case "payflowlink"
         passuser = xpayflowlink_USER
		 passmerchant = xpayflowlink_MERCHANT
		 passpartner = xpayflowlink_PARTNER
		 passpwd = xpayflowlink_PWD
		 tenderstring = "P"
		 gatewaystring = SEcureTokenGatewayPayFlowLinkURL
      case "payflowpro"
         passuser = xpayflowpro_user
		 passmerchant = xpayflowpro_merchantid
		 passpartner = xpayflowpro_partnerid
		 passpwd = xpayflowpro_pwd
		 tenderstring = "C"
		 gatewaystring = SEcureTokenGatewayPayFlowProURL
   end select
   payflowvcr_dostring anrequest,"USER",passuser
   payflowvcr_dostring anrequest,"VENDOR",passmerchant
   payflowvcr_dostring anrequest,"PARTNER",passpartner
   payflowvcr_dostring anrequest,"PWD",passpwd
   if lcase(tenderflag) = "yes" then payflowvcr_dostring anrequest,"TENDER",tenderstring
end sub

sub assignstrprefix (paymenttype,prefix)
   select case lcase(paymenttype)
      case "paypaladvanced"
         prefix = xpppymt_paymentname
      case "payflowlink"
         prefix = xpayflowlink_paymentname
      case "payflowpro"
         prefix = xpayflowpro_paymentname
   end select
end sub
%>