<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' routines for audit trail
'*********************************************************************************

'insert audit trail history
sub insertaudithistory (username,pdesc,dbc)
   on error resume next
   dim sqlstr, nowdate, nowtime, ipaddress

   '700 - 2010.06.09 - Enhancement: Admin user activities, statstic, admin/front contents compatitable with adjustdate and adjusttime
   AdjustDate nowdate
   AdjustTime nowtime
   nowdate=DateNormalize(nowdate)
   if instr(lcase(xDatabaseType),"mysql") > 0 then
      nowtime = formatdatetime(nowtime,vbshorttime)
   else
      nowtime = formatdatetime(nowtime,vblongtime)
   end if

   ipaddress = request.servervariables("REMOTE_ADDR")
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sqlstr = "insert into tblaudithist(userid,createdate,createtime,description,ipaddress) values ("& sqlserverprefixn &"'"& tosql(username,"Text") &"','"& nowdate &"','"& nowtime &"',"& sqlserverprefixn &"'"& tosql(pdesc,"Text") &"','"& ipaddress &"')"

   '800 - 2015.04.17 - Bug Fix: Admin: Error on purging admin history
   dbc.execute(sqlstr)
   on error goto 0
end sub

'purge audit trail history
sub PurgeAuditTrailHistory
   dim xauditpurgeday,xauditpurgedirectory,xauditpurgelastdate
   xauditpurgeday=getconfig("xauditpurgeday")
   if trim(xauditpurgeday) = "" then exit sub
   if isnumeric(xauditpurgeday) = false then exit sub
   if xauditpurgeday <= 0 then exit sub
	
   xauditpurgedirectory=getconfig("xauditpurgedirectory")
   xauditpurgelastdate=getconfig("xauditpurgelastdate")
	
   dim abortflag,sql,recordcnt,objrs
   recordcnt=0
   abortflag=false
   sql="select * from tbllog where flddate = " &  datedelimit(date()) & ""
   Set objrs = Server.CreateObject("ADODB.Recordset")
   Server.scripttimeout=9000

   '800 - 2015.04.17 - Enhancement: Admin: Purging admin history: Speed performance
   objrs.open sql, dbc, adOpenKeyset, adLockReadOnly

   Do while not objrs.eof
	  recordcnt=recordcnt+1
  	  objrs.MoveNext
   Loop
   if recordcnt=1 then
      abortflag=false
   else
	  abortflag=true
   end if
   closeRecordset objrs

   'abortflag = false
   if abortflag then exit sub

   dim nowdate,datedif

   '700 - 2010.06.09 - Enhancement: Admin user activities, statstic, admin/front contents compatitable with adjustdate and adjusttime
   nowdate = getnowindate

   if isnull(xauditpurgelastdate) then xauditpurgelastdate = nowdate
   if trim(xauditpurgelastdate) = "" then xauditpurgelastdate = nowdate

   '800 - 2015.10.20 - Bug Fix: 1st admin login throwing error for some specific server setup
   if not isdate(xauditpurgelastdate) then xauditpurgelastdate = nowdate

   '800 - 2015.04.17 - Bug Fix: Admin: Error on purging admin history
   dim datedelimeter
   if instr(nowdate,"-") > 0 then
      datedelimeter = "-"
   else
      datedelimeter = "/"
   end if
   xauditpurgelastdate = year(xauditpurgelastdate) & datedelimeter & month(xauditpurgelastdate) & datedelimeter & day(xauditpurgelastdate)
   nowdate = year(nowdate) & datedelimeter & month(nowdate) & datedelimeter & day(nowdate)

   datedif = datediff("d",nowdate,xauditpurgelastdate)

   '701 - 2012.01.31 - Bug Fix: Audit trail purge is not working properly   
   if datedif > -(xauditpurgeday) then
      'update xauditpurgelastdate
      dbc.execute("update "& xconfigtable &" set fieldvalue = "& datedelimit(date()) &" where fieldname = 'xauditpurgelastdate'")
      Application("Init" & "_" & xShopId)="No"
      exit sub
   end if

   on error resume next
   dim fs_overwrite,fso,fname,sMapPath,filename
   sMapPath = server.MapPath(xauditpurgedirectory)
   filename = right("0000" & year(nowdate),4) & right("00" & month(nowdate),2) & right("00" & day(nowdate),2) & right("00" & hour(nowdate),2) & right("00" & minute(nowdate),2) & right("00" & second(nowdate),2) & ".bak"
   fs_overwrite = true
   set fso=Server.CreateObject("Scripting.FileSystemObject")
   set fname=fso.CreateTextFile(""& sMapPath &"\"& filename &"",fs_overwrite)

   if err.number <> 0 then 
      '701 - 2012.01.31 - Bug Fix: Audit trail purge is not working properly
      set fname = nothing
	  set fso = nothing

      '800 - 2015.04.17 - Bug Fix: Admin: Error on purging admin history
	  on error goto 0
      exit sub
   end if
   
   sql="select * from tblaudithist order by id asc"
   Set objrs = Server.CreateObject("ADODB.Recordset")
   Server.scripttimeout=9000

   '800 - 2015.04.17 - Enhancement: Admin: Purging admin history: Speed performance
   objrs.open sql, dbc, adOpenKeyset, adLockReadOnly

   Do while not objrs.eof
      fname.WriteLine(objrs("id") & "," & objrs("userid") & "," & objrs("createdate") & "," & objrs("createtime") & "," & objrs("description") & "," & objrs("ipaddress"))
	  dbc.execute("delete from tblaudithist where id = "& cdbl(objrs("id")) &"")
	  objrs.movenext
   Loop
   closeRecordset objrs
   
   '701 - 2012.01.31 - Bug Fix: Audit trail purge is not working properly
   set fname = nothing
   set fso = nothing
   
   'update xauditpurgelastdate
   '701 - 2012.01.31 - Bug Fix: Audit trail purge is not working properly
   dbc.execute("update "& xconfigtable &" set fieldvalue = "& datedelimit(date()) &" where fieldname = 'xauditpurgelastdate'")
   Application("Init" & "_" & xShopId)="No"

   '800 - 2015.04.17 - Bug Fix: Admin: Error on purging admin history
   on error goto 0
end sub
%>