<%
dim sortfield, sortupdown, itemsperpage, lowprice,highprice
dim displayfield, displaycaptions, displayfieldcount
sub GetInput
   sortfield = URLDecode(JSURLDecode(CleanChars(request("sortfield"))))
   sortupdown = URLDecode(JSURLDecode(CleanChars(request("sortupdown"))))
   itemsperpage = URLDecode(JSURLDecode(CleanChars(request("itemsperpage"))))
   lowprice = URLDecode(JSURLDecode(CleanChars(request("lowprice"))))
   highprice = URLDecode(JSURLDecode(CleanChars(request("highprice"))))
   
   if trim(itemsperpage) = "" or isnumeric(itemsperpage) = false then itemsperpage = 20

   Category = GetSess("Category") ' see what previous one was
   cat_id = GetSess("Cat_id")
   DisplayFieldCount = Request("DisplayFields").count
   if Displayfieldcount = 0 then
      SetSess "proddisplaycount", 0
   else
      DisplayFields = split(DisplayField, ", ", -1, 1)
      if DisplayFields(0) = "All" then
         Displayfieldcount = 0
      else
         Generatedisplaycaptions
      end if
      SetSessA "ProdDisplayFields", DisplayFields
      SetSess "prodDisplaycount", displayfieldcount
   end if
   if sortfield = GetLang("langcommonselect") then
      sortfield = ""
   end if

   ValidateInputData
   SetSess "Prodsortfield", sortfield
   SetSess "prodsortupdown", sortupdown
   SetSess "proditemsperpage", itemsperpage
   SetSess "prodlowprice", lowprice
   SetSess "prodhighprice", highprice
end sub

sub GenerateSQL
   SQL = GetSess("sqlnofilter")
   if sql = "" then
      sql = GetSess("Sql")
   end if
   SQL = left(SQL, instr(1, lcase(SQL), "order by") -1)

   if trim(lowprice) <> "" and isnumeric(lowprice) then
      sql = sql & " and cprice >= "& cdbl(lowprice) &""
	  SQL = left(SQL, instr(1, lcase(SQL), "and cprice >=") -1)
   end if
   
   AddFiltering
   AddSortToSelect

   if sql <> "" then
      if sortfield<>"" then
         sql = sql & " order by " & sortfield & " " & sortupdown
      else
         sql = sql & " order by " & GetConfig("xsortproducts")
      end if
   end if
end sub

sub AddFiltering
   if trim(lowprice) <> "" and isnumeric(lowprice) then
      sql = sql & " and cprice >= "& cdbl(lowprice) &""
   end if
   if trim(highprice) <> "" and isnumeric(highprice) then
      sql = sql & " and cprice <= "& cdbl(highprice) &""
   end if
end sub

sub GenerateDisplaycaptions
   dim Prodfields, prodheader, capcount, i, caption
   redim displaycaptions(displayfieldcount -1)
   SetupProductFields ProdFields, ProdHeader
   capcount = 0
   for i = 0 to ubound(displayfields)
      locatecaption caption, displayFields(i), prodfields, prodheader
      displaycaptions(capcount) = caption
      capcount = capcount + 1
   next
   SetSessA "proddisplaycaptions", displaycaptions
end sub

sub locatecaption (caption, fieldname, prodfields, prodheader)
   dim i
   for i = 0 to ubound(Prodfields)
      if ucase(fieldname) = ucase(prodfields(i)) then
         caption = prodheader(i)
         exit sub
      end if
   next
   caption = "????"
end sub

'any sort fields must also be selected
'select DISTINCT p.CatalogId,cname
'changes to
'select DISTINCT p.CatalogId,cname,sortfield1,sortfield2
sub AddSorttoselect
   dim fields, pos
   if sortfield = "" then exit sub
   if ucase(xDatabaseType)<>"SQLSERVER" then exit sub
   fields = " p.CatalogId"
   if sortfield<>"" then
      '700 - 2010.08.04 - Bug Fix: Repeat sorting causing sql error while using sqlserver db
      if instr(sql, ","& sortfield &",") > 0 or instr(sql, ","& sortfield) > 0 or instr(sql, sortfield &",") > 0 then
      else
	     '701 - 2010.12.15 - Bug Fix: Possible error at while filtering products
	     if instr(sql, ",p."& sortfield &",") > 0 or instr(sql, ",p."& sortfield) > 0 or instr(sql, "p." & sortfield &",") > 0 then
		 else
	        fields = fields & "," & sortfield
		 end if
      end if
   end if

   '6.50.1 - fix error
   if instr(sql, fields) = 0 then
      '800 - 2016.11.21 - Bug Fix: Search Products: Filter: Error if choose sort by price field
      sql = replace(sql, "p.CatalogId", fields)
	  sql = replace(sql, "p.catalogid", fields)
   end if

   '800 - 2016.11.21 - Bug Fix: Search Products: Filter: Error if choose sort by price field
   if instr(sql, "cc.intCatalogId=") > 0 then
      sql = replace(sql, "cc.intCatalogId=", "cc.intCatalogId =")
   end if
   if instr(sql, "  ") > 0 then
      sql = replace(sql, "  ", " ")
   end if
   if instr(sql, "cc.intCatalogId = p.CatalogId,"& sortfield &"") > 0 then
      sql = replace(sql, "cc.intCatalogId = p.CatalogId,"& sortfield &"", "cc.intCatalogId = p.CatalogId")
   end if
end sub

'VP-ASP Security Patch - 10 September 2008
sub ValidateInputData
   dim vfsql, vfrs, f

   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      vfsql = "select * from products limit 0,"& itemsperpage &""
   else
      vfsql = "select TOP "& itemsperpage &" * from products"
   end if

   Set vfrs = Server.CreateObject("ADODB.Recordset")
   vfrs.open vfsql, dbc, adOpenStatic, adLockReadOnly
   if not verifyFieldName(sortfield, vfrs) then
      sortfield = ""
   end if

   if ucase(sortupdown) <> "ASC" and ucase(sortupdown) <> "DESC" then
      sortupdown = ""
   end if

   CloseRecordSet vfrs
end sub

'VP-ASP Security Patch - 10 September 2008
function verifyFieldName (fieldname, vfrs)
   dim f
   verifyFieldName = False

   for each f In vfrs.Fields
      if ucase(f.name) = ucase(fieldname) then
         verifyFieldName = True
      end if
   next
end function
%>