<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' This routine calculates tax
'*********************************************************************************

sub CalculateTax (subtotal, total, shippingcost, tax, pst)
   '800 - 2015.04.28 - Enhancement: Better handling on numeric variable
   subtotal = tonum(subtotal)
   total = tonum(total)
   shippingcost = tonum(shippingcost)
   tax = tonum(tax)
   pst = tonum(pst)

   dim rc
   dim taxdone, taxprice
   Tax = 0
   taxdone = false
   TaxCheckcustomerexcept dbc, rc ' is customer exempt
   if rc = 0 then ' yes then no tax
      exit sub
   end if

   ' the tax price can include shipping or discounts
   if GetConfig("xtaxincludeshipping") = "Yes" then
      taxprice = subtotal + shippingcost
   else
      if GetConfig("xtaxincludediscount") = "No" then
         taxprice = total
      else
         taxprice = subtotal
      end if
   end if

   ' some products are tax free, so we need to ReCalculate the real product total
   if GetConfig("xtaxexcludeproducts")<>"" or GetConfig("xtaxexcludeproductsdb")<>"" or GetConfig("xtaxfreeproducts") = "Yes" then
      taxCalculatenewsubtotal taxprice
	  
	  '6504 - BUG - Negative tax on certain conditions
	  if taxprice <= 0 then
         tax = 0
         exit sub
      end if

      if GetConfig("xtaxincludeshipping") = "Yes" then
         taxprice = taxprice+shippingcost
      end if
   end if

   '702 - 2012.08.15 - Bug Fix: Handling should be included for tax
   if trim(getsess("Handling")) <> "" then
      '702 - 2014.02.21 - Bug Fix: To ensure handling is always treated as numeric in tax module
      if isnumeric(getsess("Handling")) then taxprice = cdbl(taxprice) + cdbl(getsess("Handling"))
   end if

   '800 - 2016.08.05 - Bug Fix: Tax should be calculated with xdefaultcountry if country session is empty
   dim country
   country = GetSess("country")
   if trim(country) = "" then
      if trim(getconfig("xdefaultcountry")) <> "" then
	     country = getconfig("xdefaultcountry")
	  end if
   end if
   if ucase(country) = "CA" then

      TaxbyCanada taxprice, tax, taxdone, dbc, pst
      if taxdone = True then
         exit sub
      end if
   end if

   ' Most common is tax by state
   TaxbyState taxprice, tax, taxdone, dbc
   if taxdone = True then
      exit sub
   end if

   '6504 - BUG FIXED - SHOPTAX.ASP EU VAT ISSUES
   TaxforEU taxprice, tax, taxdone, dbc
   if taxdone = true then
      exit sub
   end if

   Taxbycountry taxprice, tax, taxdone, dbc
   if taxdone = true then
      exit sub
   end if

   TaxbyProduct taxprice, tax, taxdone, dbc
end sub

' first get state. Some tax by shipping state and others by the ordering state
' Handle By State/Province
sub TaxbyState (price, tax, taxdone, dbc)
   dim state, taxsql, taxrs
   dim xfactor, xnet, rate
   if GetConfig("xtaxshippingstate") = "Yes" then
      state = GetSess("shipstate")
      if state = "" then
         state = GetSess("state")
      end if
   else
      state = GetSess("state")
   end if
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   taxsql = "select * from shopstates where stateabbrev="& sqlserverprefixn &"'" & state & "'"
   taxsql = taxsql & " and (statetaxrate <> 0 and statetaxrate is not null)"
   Set taxrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.06.01 - Better handling on database connection on shoptax.asp
   taxrs.open taxsql, dbc, adOpenStatic, adLockReadOnly

   if not taxrs.eof then ' this state taxes
      rate = taxrs("statetaxrate") ' get rate
      rate = csng(rate) ' convert to number
      ' if atx included in price this adjusts the tax value
      if GetConfig("xtaxincludedinprice") = "Yes" then
         xfactor = (rate * 100) + 100
         xnet = (price / xfactor) * 100
         tax = price - xnet
      else
         tax = rate * price
      end if
      taxdone = true 'finished
   end if
   CloseRecordSet taxrs ' close tax recordset

   '702 - 2012.09.18 - Bug Fix : Better handling on discount, handling, tax value
   tax = Round(tax,GetConfig("xdecimalpoint"))
end sub

' see if this country has a tax rate
' if yes calculate tax
sub TaxbyCountry (price, tax, taxdone, dbc)
   dim taxsql, taxrs, country
   dim xfactor, xnet, rate
   country = ucase(GetSess("country"))

   '800 - 2016.08.05 - Bug Fix: Tax should be calculated with xdefaultcountry if country session is empty
   if trim(country) = "" then
      if trim(getconfig("xdefaultcountry")) <> "" then
	     country = getconfig("xdefaultcountry")
	  end if
   end if
   country = ucase(country)

   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   taxsql = "select * from shopcountries where country="& sqlserverprefixn &"'" & country & "'"
   taxsql = taxsql & " and (countrytaxrate <> 0 and countrytaxrate is not null)"
   Set taxrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.06.01 - Better handling on database connection on shoptax.asp
   taxrs.open taxsql, dbc, adOpenStatic, adLockReadOnly

   if not taxrs.eof then ' this state taxes
      rate = taxrs("countrytaxrate") ' get rate
      rate = csng(rate) ' convert to number
      ' if atx included in price this adjusts the tax value
      if GetConfig("xtaxincludedinprice") = "Yes" then
         xfactor = (rate * 100) + 100
         xnet = (price / xfactor) * 100
         tax = price - xnet
      else
         tax = rate * price
      end if
      taxdone = true 'finished
   end if
   CloseRecordSet taxrs ' close tax recordset

   '702 - 2012.09.18 - Bug Fix : Better handling on discount, handling, tax value
   tax = Round(tax,GetConfig("xdecimalpoint"))
end sub

' We are now looking at tax by individual product
sub TaxbyProduct (iprice, tax, taxdone, dbc)
   dim taxfield, useproductdbc
   taxfield = GetConfig("xtaxbyproduct")
   if taxfield = "" then exit sub
   dim productname, quantity, price
   dim scartitem, ArrCart, productid, productcode, taxforitem
   dim taxamount
   dim i
   dim productql
   dim rsitem
   if GetConfig("xproductdb")<>"" then
      useproductdbc = true
   else
      useproductdbc = false
   end if

   ' go through each item in the cart
   ' get CatalogId and see if it is taxable
   scartItem = GetSess("CartCount") ' number of products
   ArrCart = GetSessa("CartArray")
   for i = 1 to scartItem
      productid = ArrCart(cProductid, i)
      productcode = ArrCart(cProductCode, i)
      productname = ArrCart(cProductname, i)
      quantity = ArrCart(cQuantity, i)
      Price = ArrCart(cUnitPrice, i)
      productql = "select * from products where CatalogId=" & productid
      Set rsItem = Server.CreateObject("ADODB.Recordset")

      '800 - 2015.06.01 - Better handling on database connection on shoptax.asp
	  rsItem.open Productql, dbc, adOpenStatic, adLockReadOnly

      taxforitem = 0
      if not rsItem.eof then
         if not isnull(rsitem(taxfield)) then
            taxamount = rsitem(taxfield)
            taxamount = csng(taxamount)
            TaxforItem = Quantity * Price * taxamount
         end if
      end if
      Tax = Tax + TaxForItem
      CloseRecordSet rsitem
   next
   taxdone = true

   '702 - 2012.09.18 - Bug Fix : Better handling on discount, handling, tax value
   tax = Round(tax,GetConfig("xdecimalpoint"))
end sub

' 700 - Tax Inclusive/Exclusive Price Display
sub TaxbyProductID (tax, taxdone, iprice, productid)
   dim taxfield
   taxfield = GetConfig("xtaxbyproduct")
   if taxfield = "" then exit sub
   dim taxamount
   dim i
   dim productql
   dim rsitem
   dim Quantity

   productql = "select * from products where CatalogId=" & productid
   Set rsItem = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.06.01 - Better handling on database connection on shoptax.asp
   rsItem.open Productql, dbc, adOpenStatic, adLockReadOnly

   Quantity = 1
   if not rsItem.eof then
      if not isnull(rsitem(taxfield)) then
         taxamount = rsitem(taxfield)
         taxamount = csng(taxamount)
         tax = Quantity * iprice * taxamount
      end if
   end if
   CloseRecordSet rsitem
   taxdone = true

   '702 - 2012.09.18 - Bug Fix : Better handling on discount, handling, tax value
   tax = Round(tax,GetConfig("xdecimalpoint"))
end sub

' The last calculation is same as tax by country
' except that with a valid vat number, it could be tax exempt
sub TaxforEU (taxprice, tax, taxdone, dbc)
   ' This routine calculates tax foe EU countries
   ' If the order is for anyone in the country list above, set tax at 17.5%
   ' Inputs are
   dim xcountryname, xtaxrate
   dim xfactor, xnet
   if GetConfig("xTaxEu")<>"Yes" then exit sub
   taxdone = true
   ' No tax if valid vat number
   if GetSess("vatnumbertax")<>"" then exit sub
   ' treat it as a normal country
   TaxbyCountry taxprice, tax, taxdone, dbc
end sub

' Exclude some products such as gift certificates
sub TaxCalculatenewsubtotal (newsubtotal)
   dim scartItem, giftproductid
   dim ArrCart
   dim i
   dim ProdQuantity, prodprice
   dim foundproduct, productid
   dim products(100), productcount
   dim dbfield
   dbfield = GetConfig("xtaxexcludeproductsdb")
   if GetConfig("xtaxexcludeproducts")<>"" then
      ParseRecord GetConfig("xtaxexcludeproducts"), products, productcount, ","
      for i = 0 to productcount -1
         Products(i) = clng(products(i))
      next
   else
      productcount = 0
   end if
   scartItem = GetSess("cartcount")
   ArrCart = GetSessa("cartarray")

   newsubtotal = 0
   ' go through all products and add up the quantities
   for i = 1 to scartItem
      productid = ArrCart(cProductid, i)
      if isnumeric(productid) then
         productid = clng(productid)
      else
         productid = 0
      end if
      '800 - 2015.05.20 - Better handling numeric value from cart items
      ProdQuantity = tonum(ArrCart(cQuantity, i))
      ProdPrice = tonum(ArrCart(cUnitPrice, i))

      foundproduct = false
      if productcount>0 then
         foundproduct = taxFindproduct(productid, products, productcount)
      end if
      if foundproduct = false then
         if dbfield<>"" or GetConfig("xtaxfreeproducts") = "Yes" then
            foundproduct = taxFindProductdb(productid, dbc, dbfield)
         end if
      end if
      if foundproduct = false then
         '800 - 2015.05.20 - Better handling numeric value from cart items
         Newsubtotal = cdbl(newsubtotal) + cdbl(ProdQuantity) * cdbl(ProdPrice)
      end if
   next

   '6.50.4 Bugs Fix - 08 October 2008
   if GetSess("discount") <> "" then
      if isnumeric(GetSess("discount")) and newsubtotal > 0 then
         '800 - 2015.05.20 - Better handling numeric value from cart items
         newsubtotal = cdbl(newsubtotal) - cdbl(GetSess("discount"))
      end if
   end if

   '701 - 2012.04.27 - Bug Fix: Tax should exclude coupon discount (in percent) from items that excluded
   dim CouponPercentOnly
   CouponPercentOnly = getCouponPercentOnly (GetSess("coupon"))
   if isnull(CouponPercentOnly) = False then
      if trim(CouponPercentOnly) <> "" and cstr(CouponPercentOnly) <> "0" then
         '800 - 2015.05.20 - Better handling numeric value from cart items
         newsubtotal = cdbl(newsubtotal) - (cdbl(newsubtotal) * cdbl(couponpercent))
	     exit sub
      end if
   end if

   if GetSess("coupondiscount") <> "" then
      if isnumeric(GetSess("coupondiscount")) and newsubtotal > 0 then
         '800 - 2015.05.20 - Better handling numeric value from cart items
         newsubtotal = cdbl(newsubtotal) - cdbl(GetSess("coupondiscount"))
      end if
   end if
end sub

function TaxFindProduct (productid, products, productcount)
   dim i
   for i = 0 to productcount -1
      if productid = products(i) then
         taxfindproduct = true
         exit function
      end if
   next
   taxfindproduct = false
end function

' Find product in Database
' if field in taxexemptfieldd is not null it is taxexempt
' or in 6.50 it can be marked taxfree in the product record
function TaxFindProductDB (productid, dbc, taxfield)
   dim productsql, rsItem, taxvalue, found
   found = false

   '800 - 2015.07.01 - Bug Fix: Tax not working with gift-type product
   dim tempproductid
   if cstr(productid) = cstr(getconfig("xgiftproductid")) then
      tempproductid = session("ordergiftproductid")
   else
      tempproductid = productid
   end if
   productsql = "select * from products where CatalogId=" & tempproductid

   Set rsItem = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.06.01 - Better handling on database connection on shoptax.asp
   rsItem.open Productsql, dbc, adOpenStatic, adLockReadOnly

   if not rsItem.eof then
      if taxfield<>"" then
         taxvalue = rsitem(taxfield)
         if not isnull(taxvalue) then
            found = true
         end if
      end if

      '6.50.1 - fix check for tax free products
      if GetConfig("Xtaxfreeproducts") = "Yes" then
         taxvalue = rsitem("taxfree")
         if taxvalue then
            found = True
         end if
      end if
   end if
   CloseRecordSet rsitem
   TaxFindProductdb = found
end function

' see if this customer is taxexmpt
' set rc=0 if yes
' If using split Databases then open customerdb
sub TaxCheckcustomerexcept (dbc, rc)
   '800 - 2015.06.01 - Bug Fix: Onepage checkout: Guest checkout: Tax is not working properly
   rc = 4

   dim custsql, custrs
   if GetSess("CustomerID") = "" then exit sub ' no customer
   custsql = "select taxexempt from customers where contactid = " & GetSess("CustomerID")
   Set custrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.06.01 - Better handling on database connection on shoptax.asp
   custrs.open custsql, dbc, adOpenStatic, adLockReadOnly

   if not custrs.eof then
      if lcase(custrs("taxexempt")) = "yes" or lcase(custrs("taxexempt")) = "true" then
         rc = 0
      else
         rc = 4
      end if
   end if
   CloseRecordSet custrs
end sub

' Canadian Tax Handling
sub TaxbyCanada(price, tax, taxdone, dbc, pst)
   dim castate, cataxsql, cataxrs
   dim caxfactor, caxnet, carate, capst
   if GetConfig("xtaxshippingstate") = "Yes" then
      castate = GetSess("shipstate")
      if castate = "" then
         castate = GetSess("state")
      end if
   else
      castate = GetSess("state")
   end if
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   cataxsql = "select * from shopstates where stateabbrev="& sqlserverprefixn &"'" & castate & "'"
   cataxsql = cataxsql & " and (statetaxrate <> 0 and statetaxrate is not null)"
   Set cataxrs = Server.CreateObject("ADODB.Recordset")

   '800 - 2015.06.01 - Better handling on database connection on shoptax.asp
   cataxrs.open cataxsql, dbc, adOpenStatic, adLockReadOnly

   if not cataxrs.eof then ' this state taxes
      carate = cataxrs("statetaxrate") ' get rate
      carate = csng(carate) ' convert to number
      capst = cataxrs("statecanadapst")
      if capst > "" then
         capst = csng(capst) ' convert to number
      end if

      if capst > "" then
         '6.50.1 - special cases for tax
         if GetConfig("xtaxincludedinprice") = "Yes" then
            if lcase(castate) = "qc" or lcase(castate) = "pe" then
               caxfactor = (capst * 100) + 100
               caxnet = (price / caxfactor) * 100
               capst = price - caxnet
               caxfactor = (carate * 100) + 100
               caxnet = ((price + capst) / caxfactor) * 100
               tax = (price + capst) - caxnet
            else
               caxfactor = (carate * 100) + 100
               caxnet = (price / caxfactor) * 100
               tax = price - caxnet
               caxfactor = (capst * 100) + 100
               caxnet = (price / caxfactor) * 100
               capst = price - caxnet
            end if
         else
            if lcase(castate) = "qc" or lcase(castate) = "pe" then
			   '701 - 2011.07.26 - Bug Fix: Canada Tax
			   tax = carate * price
               pst = capst * (price + tax)
            else
               tax = carate * price
               pst = capst * price
            end if
         end if
      else
         ' if atx included in price this adjusts the tax value
         if GetConfig("xtaxincludedinprice") = "Yes" then
            caxfactor = (carate * 100) + 100
            caxnet = (price / caxfactor) * 100
            tax = price - caxnet
         else
            tax = carate * price
         end if
      end if
      taxdone = true 'finished
   end if
   CloseRecordSet cataxrs ' close tax recordset

   '702 - 2012.09.18 - Bug Fix : Better handling on discount, handling, tax value
   tax = Round(tax,GetConfig("xdecimalpoint"))
end sub

'701 - 2012.04.27 - Bug Fix: Tax should exclude coupon discount (in percent) from items that excluded
function getCouponPercentOnly (couponid)
   if trim(couponid) = "" then
      getCouponPercentOnly = ""
	  exit function
   end if
   dim sqlTC, rsTC, tempstring
   tempstring = ""
   sqlTC = "select couponpercent from coupons where couponname="& sqlserverprefixn &"'" & couponid &"'"
   set rsTC = Server.createobject("ADODB.Recordset")
   rsTC.open sqlTC, dbc, adOpenStatic, adLockReadOnly
   if not rsTC.eof then
      tempstring = rsTC("couponpercent")
   end if
   closerecordset rsTC
   getCouponPercentOnly = tempstring
end function
%>