<%
'*********************************************************************************
' 8.00
' To verify if Email Valid
'*********************************************************************************

function IsEmailValid(strEmail)
   dim strArray
   dim strItem
   dim i
   dim c
   dim blnIsItValid

   ' assume the email address is correct
   blnIsItValid = true

   ' split the email address in two parts: name@domain.ext
   strArray = split(strEmail, "@")

   ' if there are more or less than two parts
   if ubound(strArray) <> 1 then
      blnIsItValid = false
      IsEmailValid = blnIsItValid
      exit function
   end if

   ' check each part
   for each strItem In strArray
      ' no part can be void
      if len(strItem) <= 0 then
         blnIsItValid = false
         IsEmailValid = blnIsItValid
         exit function
      end if

      ' check each character of the part
      ' only following "abcdefghijklmnopqrstuvwxyz_-."
      ' characters and the ten digits are allowed
      for i = 1 to len(strItem)
         c = lcase(mid(strItem, i, 1))
         ' if there is an illegal character in the part
         if instr("abcdefghijklmnopqrstuvwxyz_-.", c) <= 0 and not isnumeric(c) then
            blnIsItValid = false
            IsEmailValid = blnIsItValid
            exit function
         end if
      next

      ' the first and the last character in the part cannot be . (dot)
      if left(strItem, 1) = "." or right(strItem, 1) = "." then
         blnIsItValid = false
         IsEmailValid = blnIsItValid
         exit function
      end if
   next

   ' the second part (domain.ext) must contain a . (dot)
   if instr(strArray(1), ".") <= 0 then
      blnIsItValid = false
      IsEmailValid = blnIsItValid
      exit function
   end if

   ' check the length oh the extension
   i = len(strArray(1)) - InStrRev(strArray(1), ".")
   ' the length of the extension can be only 2, 3, or 4
   ' to cover the new "info" extension
   if i <> 2 and i <> 3 and i <> 4 then
      blnIsItValid = false
      IsEmailValid = blnIsItValid
      exit function
   end if

   ' after . (dot) cannot follow a . (dot)
   if instr(strEmail, "..") > 0 then
      blnIsItValid = false
      IsEmailValid = blnIsItValid
      exit function
   end if

   ' finally it's OK
   IsEmailValid = blnIsItValid
end function
%>