<%
'*********************************************************************************
' 8.00
' 22 Feb 2016
' Support TLS 1.2
'*********************************************************************************

'800 - Enhancement: Add XML5, XML6 component. Auto selection on XML component. Integrate all Shopxmlhttp routines.
'800 - 2015.11.13 - XML: To support TLS1.2
sub Shopxmlhttp_v8 (itype, iurl, indata, outdata, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword)
   dim ucitype, url, ucmethod
   xmlerror=""
   outdata=""
   url=iurl
   ucmethod=UCASE(Method)
   if ucmethod="" then
      ucmethod="POST"
   end if
   If ucmethod="GET" then
      url = url & "?" & indata
   end if  
   ucitype=ucase(Itype)
   if ucitype="" or lcase(ucitype) = "auto" then
      ucitype=CheckXMLVersion
	  if lcase(ucitype) = "error" then
	     outdata="Unknown XML interface"
	     exit sub
	  end if
      ucitype=ucase(ucitype)
   end if
   
   On error resume next
   Select Case ucitype
      case "XML2"
         '800 - 2015.11.13 - XML: To support TLS1.2
         Shopxml_microsoft_v8 "Msxml2.ServerXMLHTTP", url, indata, outdata, ucmethod, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword
      Case "XML3"
         '800 - 2015.11.13 - XML: To support TLS1.2
         Shopxml_microsoft_v8 "Microsoft.XMLHTTP", url, indata, outdata, ucmethod, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword
      case "XML4"
         '800 - 2015.11.13 - XML: To support TLS1.2
         Shopxml_microsoft_v8 "MSXML2.ServerXMLHTTP.4.0", url, indata, outdata, ucmethod,xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword
      case "XML5"
         '800 - 2015.11.13 - XML: To support TLS1.2
         Shopxml_microsoft_v8 "MSXML2.ServerXMLHTTP.5.0", url, indata, outdata, ucmethod,xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword
      case "XML6"
         '800 - 2015.11.13 - XML: To support TLS1.2
         Shopxml_microsoft_v8 "MSXML2.ServerXMLHTTP.6.0", url, indata, outdata, ucmethod,xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword
      case "DYNUHTTP"
         Shopdynuhttp_v8 url, indata, outdata, ucmethod,xmlerror, rheadercnt, rheadertypeary, rheadervalueary
      case "ASPTEAR"
         Shopasptear_v8 url, indata, outdata, ucmethod,xmlerror, rheadercnt, rheadertypeary, rheadervalueary

      '800 - 2015.11.13 - XML: To support TLS1.2
      case "WINHTTP51"
	     Shopxml_winhttp "WinHttp.WinHttprequest.5.1", url, indata, outdata, ucmethod,xmlerror, rheadercnt, rheadertypeary, rheadervalueary, 0, strLogin, strPassword

      case else
         outdata="Unknown XML interface"
   end select
   if err.number<> 0 then
      xmlerror=err.description
      xmlerror=xmlerror & "<br>Using " & Itype
   end if
   on error goto 0
end sub

'800 - Auto check XML Veersion
function CheckXMLVersion
   '800 - 2015.11.13 - XML: To support TLS1.2
   if TestObject ("WinHttp.WinHttpRequest.5.1") then
      CheckXMLVersion = "WINHTTP51"
   elseif TestObject ("MSXML2.ServerXMLHTTP.6.0") then
      CheckXMLVersion = "XML6"
   elseif TestObject ("MSXML2.ServerXMLHTTP.5.0") then
      CheckXMLVersion = "XML5"
   elseif TestObject ("MSXML2.ServerXMLHTTP.4.0") then
      CheckXMLVersion = "XML4"
   elseif TestObject ("Microsoft.XMLHTTP") then
      CheckXMLVersion = "XML3"
   elseif TestObject ("Msxml2.ServerXMLHTTP") then
      CheckXMLVersion = "XML2"
   elseif TestObject ("SOFTWING.ASPtear") then
      CheckXMLVersion = "ASPTEAR"
   elseif TestObject ("DynuHttp.Http") then
      CheckXMLVersion = "DYNUHTTP"
   else
      CheckXMLVersion = "error"
   end if
end function

'Assign Timeout values
sub AssignXMLTimeout(xXMLresolveTimeout, xXMLconnectTimeout, xXMLsendTimeout, xXMLreceiveTimeout)
   xXMLresolveTimeout = getconfig("xXMLresolveTimeout")
   xXMLconnectTimeout = getconfig("xXMLconnectTimeout")
   xXMLsendTimeout = getconfig("xXMLsendTimeout")
   xXMLreceiveTimeout = getconfig("xXMLreceiveTimeout")
   if isnumeric(xXMLresolveTimeout) = "" then xXMLresolveTimeout = ""
   if isnumeric(xXMLconnectTimeout) = "" then xXMLconnectTimeout = ""
   if isnumeric(xXMLsendTimeout) = "" then xXMLsendTimeout = ""
   if isnumeric(xXMLreceiveTimeout) = "" then xXMLreceiveTimeout = ""
   if trim(xXMLresolveTimeout) = "" then xXMLresolveTimeout = 15000
   if trim(xXMLconnectTimeout) = "" then xXMLconnectTimeout = 15000
   if trim(xXMLsendTimeout) = "" then xXMLsendTimeout = 15000
   if trim(xXMLreceiveTimeout) = "" then xXMLreceiveTimeout = 15000
end sub

'Set header fields
sub SetMicrosoftXMLHeader(objHttp, rheadercnt, rheadertypeary, rheadervalueary)
   if trim(rheadercnt) = "" then exit sub
   if not isnumeric(rheadercnt) then exit sub
   if cdbl(rheadercnt) <= 0 then exit sub
   dim icnt
   for icnt = 0 to (rheadercnt - 1)
      objHttp.setRequestHeader rheadertypeary(icnt), rheadervalueary(icnt)
   next
end sub

'Load Microsoft default XML component
'800 - 2015.11.13 - XML: To support TLS1.2
Sub Shopxml_microsoft_v8(componentname, url, inStr, outStr, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword)
   dim objhttp
   dim xXMLresolveTimeout, xXMLconnectTimeout, xXMLsendTimeout, xXMLreceiveTimeout
   AssignXMLTimeout xXMLresolveTimeout, xXMLconnectTimeout, xXMLsendTimeout, xXMLreceiveTimeout
   set objHttp = Server.CreateObject(componentname)

   '800 - 2016.05.25 - Enhancement: TLS 1.2: Compatitable with windows 2008
   on error resume next

   objHttp.setTimeouts xXMLresolveTimeout,xXMLconnectTimeout,xXMLsendTimeout,xXMLreceiveTimeout

   '800 - 2016.05.25 - Enhancement: TLS 1.2: Compatitable with windows 2008
   on error goto 0

   '800 - 2015.11.13 - XML: To support TLS1.2
   if (trim(strLogin) <> "") and (trim(strPassword) <> "") then
      objHttp.open method, url, false, strLogin, strPassword
   else
      objHttp.open method, url, false
   end if

   SetMicrosoftXMLHeader objHttp, rheadercnt, rheadertypeary, rheadervalueary
   If Method="POST" Then
      objHttp.Send instr
   else
      objHttp.Send
   end if   
   outstr=objHttp.responseText
   if (objHttp.status <> 200 ) then
      xmlerror="Error Connecting Error code=" & objhttp.status
   end if
   set objhttp=nothing
end sub

Sub Shopdynuhttp_v8(url, inStr, outStr, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary)
   dim myHttp, httpHdrs
   Set myHttp = Server.CreateObject("DynuHttp.Http")
   myHttp.URL = url
   myHttp.QueryString = inStr
   outstr = myHttp.GetURL()
   httpHdrs = myHttp.GetHeaders()
   Set myHttp = nothing
End Sub

Sub ShopASPTEAR_v8(url, inStr, outStr, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary)
   dim tncurl, xobj, httpresp
   Const Request_POST = 1
   Const Request_GET = 2
   Set xobj = CreateObject("SOFTWING.ASPtear")
   Response.ContentType = "text/html"
   if method="POST" then 
      httpResp = xobj.Retrieve(url, Request_POST, instr, "", "")
   else
      httpResp = xobj.Retrieve(url, Request_GET, "", "", "")
   end if  
   set xobj = nothing
   outstr=httpresp
End sub

'800 - 2015.11.13 - XML: To support TLS1.2
Sub Shopxml_winhttp(componentname, url, inStr, outStr, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, tries, strLogin, strPassword)
   dim objhttp, optionflag
   dim xXMLresolveTimeout, xXMLconnectTimeout, xXMLsendTimeout, xXMLreceiveTimeout
   AssignXMLTimeout xXMLresolveTimeout, xXMLconnectTimeout, xXMLsendTimeout, xXMLreceiveTimeout
   set objHttp = Server.CreateObject(componentname)
   objHttp.SetTimeouts xXMLresolveTimeout,xXMLconnectTimeout,xXMLsendTimeout,xXMLreceiveTimeout
   objHttp.open method, url, false
   optionflag = true
   if tries = 0 then
      on error resume next
      objHTTP.Option(9) = 2048
      if err.number <> 0 then
         optionflag = false
      end if
      on error goto 0
   else
      objHTTP.Option(9) = 128
   end if
   if (trim(strLogin) <> "") and (trim(strPassword) <> "") then
       objHTTP.SetCredentials strLogin, strPassword, 0
   end if
   SetMicrosoftXMLHeader objHttp, rheadercnt, rheadertypeary, rheadervalueary
   on error resume next
   If Method="POST" Then
      objHttp.Send instr
   else
      objHttp.Send
   end if
   if err.number <> 0 or not optionflag then
      set objhttp=nothing
      on error goto 0

	  '800 - 2016.05.25 - Enhancement: TLS 1.2: Compatitable with windows 2008
	  if TestObject ("MSXML2.XMLHTTP.6.0") then
	     Shopxml_microsoft_v8 "MSXML2.XMLHTTP.6.0", url, inStr, outStr, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword
	  else
	     Shopxml_winhttp componentname, url, inStr, outStr, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, 1, strLogin, strPassword
	  end if
	  exit sub
   end if
   on error goto 0
   outstr=objHttp.ResponseText
   if (objHttp.status <> 200 ) then
      if tries = 0 then
	     set objhttp=nothing

		 '800 - 2016.05.25 - Enhancement: TLS 1.2: Compatitable with windows 2008
   	     if TestObject ("MSXML2.XMLHTTP.6.0") then
	        Shopxml_microsoft_v8 "MSXML2.XMLHTTP.6.0", url, inStr, outStr, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, strLogin, strPassword
	     else
	        Shopxml_winhttp componentname, url, inStr, outStr, method, xmlerror, rheadercnt, rheadertypeary, rheadervalueary, 1, strLogin, strPassword
	     end if
		 exit sub
	  else
         xmlerror="Error Connecting Error code=" & objhttp.status
      end if
   end if
   set objhttp=nothing
end sub
%>